//////////////////////////////////////////////////////////////////////////////
//
// "Embedded C Programming: Techniques and Applications of C and PIC MCUs"
// by Mark Siegusmund
//
// Exercise 16-1 #1
//
// The green LED is on until the push button is pressed. Then just the yellow
// LED is turned on for one second after release of the push button. Then
// just the red LED is turned on for one second. finaly, all LEDs are turned
// off and the buzzer plays a 1 khz tone for 3 seconds.
//
//////////////////////////////////////////////////////////////////////////////

#include <e3.h>

#define GREEN_LED PIN_C6
#define YELLOW_LED PIN_C4
#define RED_LED PIN_C3
#define PUSH_BUTTON PIN_C1

typedef enum {GREEN, YELLOW, RED} colors;

void lights(void);
void leds_off(void);
void light_one_led(colors led);
void wait_for_one_press(void);
void sound(void);

void main(void) 
{
   lights () ;
   sound () ;
   
   for (;;) ;
}

void lights(void) 
{
   light_one_led (GREEN) ;
   wait_for_one_press () ;
   light_one_led (YELLOW) ;
   delay_ms (1000) ;
   light_one_led (RED) ;
   delay_ms (1000) ;
   leds_off () ;
}

void leds_off(void) 
{
   output_low (GREEN_LED) ;
   output_low (YELLOW_LED) ;
   output_low (RED_LED) ;
}

void light_one_led(colors led) 
{
   leds_off () ;
   
   switch (led)
   {
      case GREEN: output_high (GREEN_LED); break;
      case YELLOW: output_high (YELLOW_LED); break;
      case RED: output_high (RED_LED); break;
   }
}

void wait_for_one_press(void) 
{
   while (input (PUSH_BUTTON)) ;
   delay_ms (100) ;
   while ( ! input (PUSH_BUTTON)) ;
}

void sound(void) 
{
   for (int i = 0; i < 15; i++)
   {
      for (int16 j = 0; j < 200; j++)
      {
         output_high (PIN_B4) ;
         delay_us (500) ;
         output_low (PIN_B4) ;
         delay_us (500) ;
      }
   }
}

