//////////////////////////////////////////////////////////////////////////////
//
// "Embedded C Programming: Techniques and Applications of C and PIC MCUs"
// by Mark Siegusmund
//
// Exercise 16-1 #2
//
// Displays the numbers 0-9 on a 7-segment display for one second each.
//
// To see an example of writing to both digits of a 2 digit 7-segment display,
// see ex_sk_7seg_led.c in the CCS C Compiler's example folder.
//
//////////////////////////////////////////////////////////////////////////////

#include <E3.h>

#define PIN_7SEG_A         PIN_B4
#define PIN_7SEG_B         PIN_B5
#define PIN_7SEG_C         PIN_B6
#define PIN_7SEG_D         PIN_B7
#define PIN_7SEG_E         PIN_C5
#define PIN_7SEG_F         PIN_C6
#define PIN_7SEG_G         PIN_C7

const char g_7SegCharBitmaps[] =
{
   0x3f, //0
   0x06, //1
   0x5b, //2
   0x4f, //3
   0x66, //4
   0x6d, //5
   0x7d, //6
   0x07, //7
   0x7f, //8
   0x6f  //9
};

// number can be 0-9
void display(int number)
{
   int bitmap;
   
   bitmap = g_7SegCharBitmaps[number];
   
   output_bit(PIN_7SEG_A, bit_test(bitmap, 0));
   output_bit(PIN_7SEG_B, bit_test(bitmap, 1));
   output_bit(PIN_7SEG_C, bit_test(bitmap, 2));
   output_bit(PIN_7SEG_D, bit_test(bitmap, 3));
   output_bit(PIN_7SEG_E, bit_test(bitmap, 4));
   output_bit(PIN_7SEG_F, bit_test(bitmap, 5));
   output_bit(PIN_7SEG_G, bit_test(bitmap, 6));
}

void main(void) 
{
   for(;;) 
   {
      for(int i = 0; i <= 9; i++) 
      {
         display(i);
         delay_ms(1000);
      }
   }
}
