//////////////////////////////////////////////////////////////////////////////
//
// "Embedded C Programming: Techniques and Applications of C and PIC MCUs"
// by Mark Siegusmund
//
// Exercise 16-1 #3
//
// Displays the key pressed on a 3x4 keypad attached to the PIC.
//
//////////////////////////////////////////////////////////////////////////////

#include <e3.h>

#define KBD_USES_PULLUPS

#define KBD_COL1  PIN_B6
#define KBD_COL2  PIN_B7
#define KBD_COL3  PIN_C5

#define KBD_ROW1  PIN_C1
#define KBD_ROW2  PIN_C2
#define KBD_ROW3  PIN_B4
#define KBD_ROW4  PIN_B5

#include <kbd3.c>

void main(void) 
{
   char c;
   
   // enable pullups on the row pins PIN_B4 and PIN_B5.  PIN_C1 and PIN_C2
   // are also row pins but have a pull-up resistor on the PCB.
   port_b_pullups(0x30);
   
   kbd_init();
   
   for(;;) 
   {
      c = kbd_getc();
      
      if (c)
      {
         printf("got = '%c'\r\n", c);
      }
   }
}
